import java.util.*;

class Pair implements Comparable<Pair> {
    int first, second;

    public Pair(int first, int second) {
        this.first = first;
        this.second = second;
    }

    public int compareTo(Pair other) {
        return this.first-other.first;
    }
}

public class Antti {
    public static void main(String[] args) {
        Scanner input = new Scanner(System.in);
        int n = input.nextInt();
        int m = input.nextInt();
        int k = input.nextInt();
        if (k%m != 0 || k/m < 1 || k/m > n) {
            System.out.println("impossible");
            return;
        }
        int t = k/m;
        ArrayList<Pair> a = new ArrayList<>();
        for (int i = 1; i <= n; i++) {
            int x = input.nextInt();
            a.add(new Pair(x,i));
        }
        Collections.sort(a);
        int x = n-t-1;
        int y = n-t;
        ArrayList<Integer> r = new ArrayList<>();
        r.add(a.get(y).second);
        y++;
        int c = 1;
        for (int i = 2; i <= n; i++) {
            if (y < n && c*m <= a.get(y).first*(i-1)) {
                c++;
                r.add(a.get(y).second);
                y++;
            } else if (x >= 0 && c*m > a.get(x).first*(i-1)) {
                r.add(a.get(x).second);
                x--;
            } else {
                System.out.println("impossible");
                return;
            }
        }
        for (int i = 0; i < n; i++) {
            System.out.print(r.get(i)+" ");
        }
        System.out.println();
    }
}
