
import java.util.StringTokenizer;
import java.io.BufferedReader;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.OutputStream;
import java.util.*;

public class Antti_buffered {
    public static void main(String[] args) {
        Kattio io = new Kattio(System.in);
        int n = io.getInt();
        long[] t = new long[n];
        long[] a = new long[n];
        long[] b = new long[n];
        long mf = 0, mt = 0;
        for (int i = 0; i < n; i++) {
            t[i] = io.getInt();
            a[i] = io.getInt();
            b[i] = io.getInt();
            b[i] -= a[i];
            mf += a[i];
            mt += a[i]*t[i];
        }
        // bubble sort ftw
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n-1; j++) {
                if (t[j] > t[j+1]) {
                    long x;
                    x = t[j]; t[j] = t[j+1]; t[j+1] = x;
                    x = b[j]; b[j] = b[j+1]; b[j+1] = x;
                }
            }
        }
        int r = io.getInt();
        for (int i = 1; i <= r; i++) {
            long x = io.getInt();
            long y = io.getInt();
            if (y < mf) {
                io.println("no");
                continue;
            }
            long ay = y-mf;
            long at = mt;
            for (int j = 0; j < n; j++) {
                long nf = Math.min(b[j],ay);
                ay -= nf;
                at += nf*t[j];
            }
            long by = y-mf;
            long bt = mt;
            for (int j = n-1; j >= 0; j--) {
                long nf = Math.min(b[j],by);
                by -= nf;
                bt += nf*t[j];
            }
            if (ay == 0 && at <= x*y && x*y <= bt) {
                io.println("yes");
            } else {
                io.println("no");
            }
        }
        io.flush();
    }
}

/** Simple yet moderately fast I/O routines.
 *
 * Example usage:
 *
 * Kattio io = new Kattio(System.in, System.out);
 *
 * while (io.hasMoreTokens()) {
 *    int n = io.getInt();
 *    double d = io.getDouble();
 *    double ans = d*n;
 *
 *    io.println("Answer: " + ans);
 * }
 *
 * io.close();
 *
 *
 * Some notes:
 *
 * - When done, you should always do io.close() or io.flush() on the
 *   Kattio-instance, otherwise, you may lose output.
 *
 * - The getInt(), getDouble(), and getLong() methods will throw an
 *   exception if there is no more data in the input, so it is generally
 *   a good idea to use hasMoreTokens() to check for end-of-file.
 *
 * @author: Kattis
 */

class Kattio extends PrintWriter {
    public Kattio(InputStream i) {
        super(new BufferedOutputStream(System.out));
        r = new BufferedReader(new InputStreamReader(i));
    }
    public Kattio(InputStream i, OutputStream o) {
        super(new BufferedOutputStream(o));
        r = new BufferedReader(new InputStreamReader(i));
    }

    public boolean hasMoreTokens() {
        return peekToken() != null;
    }

    public int getInt() {
        return Integer.parseInt(nextToken());
    }

    public double getDouble() {
        return Double.parseDouble(nextToken());
    }

    public long getLong() {
        return Long.parseLong(nextToken());
    }

    public String getWord() {
        return nextToken();
    }



    private BufferedReader r;
    private String line;
    private StringTokenizer st;
    private String token;

    private String peekToken() {
        if (token == null)
            try {
                while (st == null || !st.hasMoreTokens()) {
                    line = r.readLine();
                    if (line == null) return null;
                    st = new StringTokenizer(line);
                }
                token = st.nextToken();
            } catch (IOException e) { }
        return token;
    }

    private String nextToken() {
        String ans = peekToken();
        token = null;
        return ans;
    }
}
