#!/usr/bin/env python3

k = int(input())
faucets = sorted(tuple(map(float, input().split())) for _ in range(k))
baseflow = 0
basetemp = 0
for (t, a, b) in faucets:
    baseflow += a
    basetemp += a*t


def make_flow(flow, faucets):
    if flow < 0: return (0, -1)
    temp = 0
    for (t, a, b) in faucets:
        temp += min(flow, b-a)*t
        flow -= min(flow, b-a)
    return (temp, flow)
        
for _ in range(int(input())):
    temp, flow = map(float, input().split())
    (mintemp, rem) = make_flow(flow-baseflow, faucets)
    (maxtemp, rem) = make_flow(flow-baseflow, reversed(faucets))
    print(['no','yes'][rem == 0 and (mintemp+basetemp)/flow <= temp <= (maxtemp+basetemp)/flow])
